package org.omg.CosNaming;

import org.omg.CORBA.ORB;
import org.omg.PortableServer.POA;
import org.omg.CORBA.Object;
import org.omg.CORBA.BAD_OPERATION;
import org.omg.CORBA.CompletionStatus;
import org.omg.CosNaming.NamingContextPackage.NotEmpty;
import org.omg.CosNaming.NamingContextPackage.NotEmptyHelper;
import org.omg.CosNaming.NamingContextPackage.AlreadyBound;
import org.omg.CosNaming.NamingContextPackage.AlreadyBoundHelper;
import org.omg.CosNaming.NamingContextPackage.InvalidName;
import org.omg.CosNaming.NamingContextPackage.InvalidNameHelper;
import org.omg.CosNaming.NamingContextPackage.CannotProceed;
import org.omg.CosNaming.NamingContextPackage.CannotProceedHelper;
import org.omg.CosNaming.NamingContextPackage.NotFound;
import org.omg.CosNaming.NamingContextPackage.NotFoundHelper;
import org.omg.CORBA.ObjectHelper;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.ResponseHandler;
import org.omg.CORBA.portable.InputStream;
import java.util.Hashtable;
import org.omg.CORBA.portable.InvokeHandler;
import org.omg.PortableServer.Servant;

public abstract class NamingContextPOA extends Servant implements NamingContextOperations, InvokeHandler
{
    private static Hashtable _methods;
    private static String[] __ids;
    
    public NamingContextPOA() {
    }
    
    public OutputStream _invoke(String key, InputStream inputStream, ResponseHandler responseHandler) {
        Integer n = (Integer)NamingContextPOA._methods.get(key);
        if (n == null) {
            throw new BAD_OPERATION(0, CompletionStatus.COMPLETED_MAYBE);
        }
        OutputStream outputStream;
        switch ((int)n) {
            case 0: {
                try {
                    this.bind(NameHelper.read(inputStream), ObjectHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    break;
                }
                catch (NotFound notFound) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound);
                    break;
                }
                catch (CannotProceed cannotProceed) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed);
                    break;
                }
                catch (InvalidName invalidName) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName);
                    break;
                }
                catch (AlreadyBound alreadyBound) {
                    outputStream = responseHandler.createExceptionReply();
                    AlreadyBoundHelper.write(outputStream, alreadyBound);
                    break;
                }
            }
            case 1: {
                try {
                    this.bind_context(NameHelper.read(inputStream), NamingContextHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    break;
                }
                catch (NotFound notFound2) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound2);
                    break;
                }
                catch (CannotProceed cannotProceed2) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed2);
                    break;
                }
                catch (InvalidName invalidName2) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName2);
                    break;
                }
                catch (AlreadyBound alreadyBound2) {
                    outputStream = responseHandler.createExceptionReply();
                    AlreadyBoundHelper.write(outputStream, alreadyBound2);
                    break;
                }
            }
            case 2: {
                try {
                    this.rebind(NameHelper.read(inputStream), ObjectHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    break;
                }
                catch (NotFound notFound3) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound3);
                    break;
                }
                catch (CannotProceed cannotProceed3) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed3);
                    break;
                }
                catch (InvalidName invalidName3) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName3);
                    break;
                }
            }
            case 3: {
                try {
                    this.rebind_context(NameHelper.read(inputStream), NamingContextHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    break;
                }
                catch (NotFound notFound4) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound4);
                    break;
                }
                catch (CannotProceed cannotProceed4) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed4);
                    break;
                }
                catch (InvalidName invalidName4) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName4);
                    break;
                }
            }
            case 4: {
                try {
                    org.omg.CORBA.Object resolve = this.resolve(NameHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    ObjectHelper.write(outputStream, resolve);
                    break;
                }
                catch (NotFound notFound5) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound5);
                    break;
                }
                catch (CannotProceed cannotProceed5) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed5);
                    break;
                }
                catch (InvalidName invalidName5) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName5);
                    break;
                }
            }
            case 5: {
                try {
                    this.unbind(NameHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    break;
                }
                catch (NotFound notFound6) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound6);
                    break;
                }
                catch (CannotProceed cannotProceed6) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed6);
                    break;
                }
                catch (InvalidName invalidName6) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName6);
                    break;
                }
            }
            case 6: {
                int read_ulong = inputStream.read_ulong();
                BindingListHolder bindingListHolder = new BindingListHolder();
                BindingIteratorHolder bindingIteratorHolder = new BindingIteratorHolder();
                this.list(read_ulong, bindingListHolder, bindingIteratorHolder);
                outputStream = responseHandler.createReply();
                BindingListHelper.write(outputStream, bindingListHolder.value);
                BindingIteratorHelper.write(outputStream, bindingIteratorHolder.value);
                break;
            }
            case 7: {
                NamingContext new_context = this.new_context();
                outputStream = responseHandler.createReply();
                NamingContextHelper.write(outputStream, new_context);
                break;
            }
            case 8: {
                try {
                    NamingContext bind_new_context = this.bind_new_context(NameHelper.read(inputStream));
                    outputStream = responseHandler.createReply();
                    NamingContextHelper.write(outputStream, bind_new_context);
                    break;
                }
                catch (NotFound notFound7) {
                    outputStream = responseHandler.createExceptionReply();
                    NotFoundHelper.write(outputStream, notFound7);
                    break;
                }
                catch (AlreadyBound alreadyBound3) {
                    outputStream = responseHandler.createExceptionReply();
                    AlreadyBoundHelper.write(outputStream, alreadyBound3);
                    break;
                }
                catch (CannotProceed cannotProceed7) {
                    outputStream = responseHandler.createExceptionReply();
                    CannotProceedHelper.write(outputStream, cannotProceed7);
                    break;
                }
                catch (InvalidName invalidName7) {
                    outputStream = responseHandler.createExceptionReply();
                    InvalidNameHelper.write(outputStream, invalidName7);
                    break;
                }
            }
            case 9: {
                try {
                    this.destroy();
                    outputStream = responseHandler.createReply();
                    break;
                }
                catch (NotEmpty notEmpty) {
                    outputStream = responseHandler.createExceptionReply();
                    NotEmptyHelper.write(outputStream, notEmpty);
                    break;
                }
            }
            default: {
                throw new BAD_OPERATION(0, CompletionStatus.COMPLETED_MAYBE);
            }
        }
        return outputStream;
    }
    
    public String[] _all_interfaces(POA poa, byte[] array) {
        return (String[])(String[])NamingContextPOA.__ids.clone();
    }
    
    public NamingContext _this() {
        return NamingContextHelper.narrow(super._this_object());
    }
    
    public NamingContext _this(ORB orb) {
        return NamingContextHelper.narrow(super._this_object(orb));
    }
    
    static {
        (NamingContextPOA._methods = new Hashtable()).put("bind", new Integer(0));
        NamingContextPOA._methods.put("bind_context", new Integer(1));
        NamingContextPOA._methods.put("rebind", new Integer(2));
        NamingContextPOA._methods.put("rebind_context", new Integer(3));
        NamingContextPOA._methods.put("resolve", new Integer(4));
        NamingContextPOA._methods.put("unbind", new Integer(5));
        NamingContextPOA._methods.put("list", new Integer(6));
        NamingContextPOA._methods.put("new_context", new Integer(7));
        NamingContextPOA._methods.put("bind_new_context", new Integer(8));
        NamingContextPOA._methods.put("destroy", new Integer(9));
        NamingContextPOA.__ids = new String[] { "IDL:omg.org/CosNaming/NamingContext:1.0" };
    }
}
